import readlineSync from 'readline-sync';
import { car, cdr } from 'hexlet-pairs';

const attemptCount = 3;

const iterGame = (user, count, game) => {
  if (count === 0) {
    const textWin = `\nCongratulations, ${user}`;
    return textWin;
  }
  const condition = game();
  const question = car(condition);
  const correctAnswer = cdr(condition);
  console.log(`Question: ${question}`);
  const answer = readlineSync.question('Your answer: ');

  if (correctAnswer === answer) {
    console.log('Correct!');
    return iterGame(user, count - 1, game);
  }
  const textLose = `\n${answer} is wrong anwer ;(. Correct answer was ${correctAnswer}\nLet's try again, ${user}`;
  return textLose;
};

const flow = (description, game) => {
  console.log('Welcome to the Brain Games!');
  console.log(`${description}\n`);
  const userName = readlineSync.question('May I have your name? ');
  console.log(`Hello, ${userName}\n`);

  const result = iterGame(userName, attemptCount, game);
  console.log(result);
};

export default flow;
