import { cons } from 'hexlet-pairs';
import flow from '../flow';
import { randomInteger } from '../utils';

const description = 'Balance the given number.';

const sumDigits = (num) => {
  const st = String(num);
  const length = st.length;
  if (length === 1) {
    return Number(st);
  }
  return Number(st[0]) + sumDigits(st.slice(1));
};

const findModNull = (num, div) => {
  if (num % div === 0) {
    return num;
  }
  return findModNull(num - 1, div);
};

const findBody = (base, len) => {
  if (len === 0) {
    return 0;
  }
  return base * (10 ** (len - 1)) + findBody(base, len - 1);
};

const findAdd = (num) => {
  if (num === 0) {
    return 0;
  }
  return (10 ** (num - 1)) + findAdd(num - 1);
};

const formatResult = (str, len) => {
  if (str.length === len) {
    return str;
  }
  const formatStr = `0${str}`;
  return formatResult(formatStr, len);
};

const findSolution = (num) => {
  const sumDigit = sumDigits(num);
  const lenNum = String(num).length;
  if (sumDigit < lenNum) {
    const result = findAdd(sumDigit);
    return formatResult(String(result), lenNum);
  }
  const over = sumDigit - findModNull(sumDigit, lenNum);
  const result = findBody(lenNum, lenNum) + findAdd(over);
  return String(result);
};

const balance = () => {
  const balanceRules = () => {
    const task = randomInteger(1, 9999);
    const solution = findSolution(task);

    return cons(task, solution);
  };

  return flow(description, balanceRules);
};

export default balance;
