import { cons } from 'hexlet-pairs';
import flow from '../flow';
import { randomInteger } from '../utils';

const description = 'What is the result of the expression?';

const calculator = (a, b, act) => {
  if (act === 1) {
    return a + b;
  } else if (act === 2) {
    return a - b;
  }
  return a * b;
};

const genOperator = (num) => {
  if (num === 1) {
    return '+';
  } else if (num === 2) {
    return '-';
  }
  return '*';
};

const calc = () => {
  const calcRules = () => {
    const num1 = randomInteger(1, 100);
    const num2 = randomInteger(1, 100);
    const operator = randomInteger(1, 3);

    const task = `${num1} ${genOperator(operator)} ${num2}`;
    const solution = String(calculator(num1, num2, operator));

    return cons(task, solution);
  };

  return flow(description, calcRules);
};

export default calc;
