import { cons } from 'hexlet-pairs';
import flow from '../flow';
import { randomInteger } from '../utils';

const description = 'Find the greatest common divisor of given numbers.';

const findGCD = (a, b) => {
  if (a === b) {
    return a;
  }
  if (a > b) {
    return findGCD(a - b, b);
  }
  return findGCD(a, b - a);
};

const gcd = () => {
  const gcdRules = () => {
    const basis = randomInteger(1, 10);
    const num1 = basis * randomInteger(1, 10) * randomInteger(1, 10);
    const num2 = basis * randomInteger(1, 10) * randomInteger(1, 10);

    const task = `${num1} ${num2}`;
    const solution = String(findGCD(num1, num2));

    return cons(task, solution);
  };
  return flow(description, gcdRules);
};

export default gcd;
