import { cons } from 'hexlet-pairs';
import flow from '../flow';
import { randomInteger } from '../utils';

const description = 'Answer "yes" if number prime otherwise answer "no".';

const isPrime = (num) => {
  if (num < 2) {
    return false;
  }
  let i = 2;
  while (i <= num / 2) {
    if (num % i === 0) {
      return false;
    }
    i += 1;
  }

  return true;
};

const prime = () => {
  const primeRules = () => {
    const task = randomInteger(1, 100);
    const solution = isPrime(task) ? 'yes' : 'no';

    return cons(task, solution);
  };

  return flow(description, primeRules);
};

export default prime;
