import { cons } from 'hexlet-pairs';
import flow from '../flow';
import { randomInteger } from '../utils';

const description = 'What number is missing in this progression?';

const genSequence = (firstElem, diff, numberElem, space, acc) => {
  if (numberElem === 10) {
    return acc;
  }
  if (numberElem === space) {
    const result = `${acc}, ..`;
    return genSequence(firstElem, diff, numberElem + 1, space, result);
  }
  const currentElement = firstElem + diff * (numberElem - 1);
  const result = `${acc}, ${currentElement}`;
  return genSequence(firstElem, diff, numberElem + 1, space, result);
};

const progression = () => {
  const progressionRules = () => {
    const firstElement = randomInteger(1, 10);
    const difference = randomInteger(1, 10);
    const numberElement = 2;
    const emptyPosition = randomInteger(2, 9);

    const task = genSequence(firstElement, difference, numberElement, emptyPosition, firstElement);
    const solution = String(firstElement + difference * (emptyPosition - 1));

    return cons(task, solution);
  };

  return flow(description, progressionRules);
};

export default progression;
